"{ Package: 'stx:goodies/ring' }"

"{ NameSpace: Smalltalk }"

RGClassDescriptionDefinition subclass:#RGMetaclassDefinition
	instanceVariableNames:'baseClass'
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGMetaclassDefinition comment:'RGMetaclassDefinition is a concrete representation of metaclasses of classes (traits are excluded)'
!

!RGMetaclassDefinition class methodsFor:'class initialization'!

class: anORClassDefinition

    ^self new
        baseClass: anORClassDefinition;
        yourself
! !

!RGMetaclassDefinition methodsFor:'accessing'!

baseClass: aRGClassDefinition

    baseClass:= aRGClassDefinition.
    self name: (baseClass name, ' class') asSymbol
!

category
    ^ self theNonMetaClass category
!

environment

    ^baseClass environment
!

package

    ^baseClass package
!

realClass

    ^baseClass realClass theMetaClass
!

theMetaClass

    ^self
!

theNonMetaClass

    ^baseClass
! !

!RGMetaclassDefinition methodsFor:'printing'!

storeOn: aStream
    
    aStream nextPut: $(. 
    super storeOn: aStream.
    aStream nextPutAll: ' baseClass:'.
    self theNonMetaClass storeOn: aStream.
    aStream nextPut: $).
    
! !

!RGMetaclassDefinition methodsFor:'testing'!

isMeta

    ^true
!

isSameRevisionAs: aRGMetaclassDefinition
    "This method look for equality of the properties of the receiver"

    ^(super isSameRevisionAs: aRGMetaclassDefinition)
        and:[ self traitCompositionSource = aRGMetaclassDefinition traitCompositionSource ]
! !

!RGMetaclassDefinition methodsFor:'variables'!

allClassVarNames

    ^self theNonMetaClass allClassVarNames
!

allSharedPoolNames

    ^self theNonMetaClass allSharedPoolNames
! !

